﻿using System.Data.Linq;
using System.Data.Linq.Mapping;

namespace LinqToSqlManualExample
{
	[Table(Name = "ProductIngredients")]
	public class ProductIngredient
	{
		private EntityRef<Product> _product;
		private EntityRef<Ingredient> _ingredient;

		[Column(IsPrimaryKey = true)]
		public int ProductID { get; set; }

		[Column(IsPrimaryKey = true)]
		public int IngredientID { get; set; }

		[Column]
		public decimal? Amount { get; set; }

		[Association(Storage = "_product", ThisKey = "ProductID")]
		public Product Product
		{
			get { return _product.Entity; }
			set { _product.Entity = value; }
		}

		[Association(Storage = "_ingredient", ThisKey = "IngredientID")]
		public Ingredient Ingredient
		{
			get { return _ingredient.Entity; }
			set { _ingredient.Entity = value; }
		}
	}
}
